/** @file
* PURPOSE: File contains the whole program
* Calculate a triangle
* @author Daniel Hasemann
* November 15th, 2005
*************************************************/

#include <stdio.h>
#include <stdlib.h>

int testparam(float,float,float);

/** @brief main program        
    *  
    * Defines vars, writes text in file
    @author Daniel Hasemann
    *November 15th, 2005
    ******************************************/
    
int main(int argc, char *argv[])
{
    int iretparam=0;
    float a;
    float b;
    float c;
    
    if(argc!=4)
    {
        printf("Parameterfehler! Bitte 3 Parameter eingeben!\n\n");
        system("PAUSE");
        exit(1);
    }
    
    a=atof(argv[1]);
    b=atof(argv[2]);
    c=atof(argv[3]);
      
    iretparam=testparam(a,b,c);
    
    if (!iretparam)
    {
        printf("Es ist ein beliebiges Dreieck!\n\n");
    }    
    
    system("PAUSE");	
    return 0;
}

/** @brief testparam        
    *  
    * compares the length of the sides from a triangle
    @param a is a float
    @param b is a float
    @param c is a float
    @return iretparam is an integer
    @see main()
    @author Daniel Hasemann
    *November 15th, 2005
    ******************************************/
    
int testparam(float a,float b,float c)
{
    int iretparam=0;
    
    if((a==0||b==0||c==0)||(a<0||b<0||c<0))
    {
        printf("Parameterfehler! Mindestens 1 Parameter ist <=(0)!\n\n"); 
        iretparam=1;
    } 
    else
    { 
        if((a==b)&&(a==c))
        {
            printf("Dreieck ist gleichseitig!\n\n");    
            iretparam=1;
        }
        else
        {
            if(((a==b)&&(a!=c))||((a==c)&&(a!=b))||((b==c)&&(b!=c)))
            {
                printf("Dreieck ist gleichschenklig!\n\n");
                iretparam=1;
            }
            if((a==sqrt(b*b+c*c))||(b==sqrt(a*a+c*c))||(c==sqrt(a*a+b*b)))
            {
                printf("Dreieck ist rechtwinklig!\n\n");
                iretparam=1;
            }
        }
    }
    return iretparam;
}
