/** @file ndame.h
* PURPOSE: file contains header of n-queens problem
* 
* @author Daniel Hasemann
* @version 1.0
* @date December 16th, 2005
*************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h> 
#include <string.h>
#include <time.h>

#define MAX_SIZE 12                                   //max size of chessboard
#define MIN_SIZE 4                                    //min size of chessboard
#define X_POS 55                                      //chessboard position
#define Y_POS 6                                       //chessboard position
#define BOARD_PART_1 177                              //board ascii code1
#define BOARD_PART_2 0                                //board ascii code2
#define QUEEN 1                                       //queen ascii code

enum mode
{   
    automatic,
    manual
};

struct data
{
    enum mode m1;                                     //singlestep
    int iblength;                                     //chessboard size
    int iboard[MAX_SIZE][MAX_SIZE];                   //chessboard array
    int isolutions;                                   //quantity of solutions
    int istep;                                        //jes,no(1 or 0)
    int isave;                                        //jes,no(1 or 0)
    int iauthor;                                      //text-file-header(0 or 1)
    float fcalctime;                                  //calculation time
    char cfilename[100];                              //filename array
    clock_t tstart;                                   //time start variable 
    clock_t tend;                                     //time end variable
};
