/** @file menu.c
* PURPOSE: file contains the menu function
* 
* @author Daniel Hasemann
* @version 1.0
* @date December 16th, 2005
*************************************************/

#include "ndame.h"

/** @brief menu   
*  
*In the menu you can choose between calculate, options and exit. After
*pressing (C) youll start the algorithm to calculate the solutions of
*n-queens problem. When you press (O) the programme starts a sub menu called
*options. You can exit the programme with (E).  
*@param *d1 is a struct pointer
*@return ichscan is an integer 
*@see main()
*@author Daniel Hasemann
*@date December 16th, 2005
***************************************/

int menu(struct data*d1)
{
    char chscan;
    int ii;
    int ik;
    int ichscan;
    int ic;
    
    gotoxy(5,2);
    printf("<C>alculate");
    gotoxy(25,2);
    printf("<O>ptions");
    gotoxy(47,2);
    printf("<E>xit");
    
    textcolor(C_REST);
    
    do
    {
        chscan=getch();
    }while(!((chscan=='c')||(chscan=='o')||(chscan=='e')));
    
    ichscan=(int)chscan;
    
    if(chscan=='c')
    {
        gotoxy(25,2);
    printf("         ");                              //clear options
    }
    
    if(chscan=='o')                                   
    {
        gotoxy(5,2);
    printf("           ");                            //clear calculate
    }
    
    if(chscan=='e')
    {
        return 0;
    }
    switch(chscan)
    {
        case 'c':
        d1->isolutions=0;
        for(ii=0;ii<MAX_SIZE;ii++)                    //queen - array will be cleared
        {
            for(ik=0;ik<MAX_SIZE;ik++)
            {
                d1->iboard[ii][ik]=0;
            }
        } 
        d1->tstart=clock();                           //start time
        
        if(d1->m1==manual)
        {
            chessboard(d1);                           //chessboard view when singlestep is active
        }
        
        calculate(d1,0);                              //calculate starts by row=0
        d1->tend=clock();                             //stop time
        d1->fcalctime=(float)(d1->tend-d1->tstart)/CLOCKS_PER_SEC;       //time in ms
        d1->iauthor=0;                                //after algorithm text-file-header will activated 
        state(d1,6);                                  //status of calctime
        
        if(d1->m1==manual)
        {
            clrbox(0);                                //clear left box
            clrbox(1);                                //clear right box
        }
        break;
    
        case 'o':
        options(d1);                                  //sub menu options
        break;
    }
    return ichscan;                                   //menu loop variable
}
