/** @file state.c
* PURPOSE: file prints the status of the bar on screen
* 
* @author Daniel Hasemann
* @version 1.0
* @date December 16th, 2005
*************************************************/

#include "ndame.h"

/** @brief state
*  
*This function prints the status from this programme on screen. First words
*like boardsize, singlestep etc. will be printed on lower screen. Then the file
*reads the values from the struct d1 and prints them behind the words. By using
*istate only this status which you want to update will be updated.To set default
*values Istate=0 will update all values.  
*@param *d1 is a struct pointer
*@param istate is an integer
*@return 
*@see main()
*@see menu()
*@see calculate()
*@see options()
*@see filename()
*@author Daniel Hasemann
*@date December 16th, 2005
***************************************/

void state(struct data*d1,int istate)
{
    
    textcolor(C_REST);
    
    if(!istate)                                       //prints the text by istate=0
    { 
        gotoxy(2,22);
        printf("Bordersize=");
        gotoxy(28,22);
        printf("Singlestep=");
        gotoxy(54,22);
        printf("Save=");
        gotoxy(2,24);
        printf("File=");
        gotoxy(28,24);
        printf("Solutions=");
        gotoxy(54,24);
        printf("Calctime=");
    }
    
    if(istate==0||istate==1)                          //prints value of chessboard length                   
    {
        gotoxy(13,22);
        printf("              ");
        gotoxy(13,22);
        printf("%d x %d",d1->iblength,d1->iblength);           
    }
    
    if(istate==0||istate==2)                          //prints value of single step status
    {
        gotoxy(39,22);
        printf("              ");
        gotoxy(39,22);
        if(d1->m1==automatic)
        {
            printf("no");                                      
        }
        else
        {
            printf("yes");    
        }
    }
    
    if(istate==0||istate==3)                          //prints value of save status         
    {
        gotoxy(59,22);
        printf("                     ");
        gotoxy(59,22);
        if(d1->isave)
        {
            printf("yes");
        }
        else
        {
            printf("no");
        }
    }
    
    if(istate==0||istate==4)                          //prints filename
    {
        gotoxy(7,24);
        printf("                    ");
        gotoxy(7,24);
        printf("%s",d1->cfilename);
    }      

    if(istate==0||istate==5)                          //prints value of solutions
    {
        gotoxy(38,24);
        //printf("               ");
        gotoxy(38,24);
        printf("%d     ",d1->isolutions);
    }
    
    if(istate==0||istate==6)                          //prints value of calculation time
    {
        gotoxy(63,24);
        printf("                 ");
        gotoxy(63,24);
        printf("%.3f sec",d1->fcalctime);
    }
}
